
; ============================================================
; 09-06-93
; Creates TracTuner windows
; ------------------------------------------------------------
PROC TracTunerCreateWindows_u()
   PRIVATE Procname.a,
           attrib_bag,
           h
   Procname.a = "TracTunerCreateWindows_u"
   ;- we need three windows: Triggers, Procs, Watch
   ECHO OFF
   h = SaveWindowHandle_n()
   ;--update var memory estimate
   tr_varmem_a = "Not Available"
    ; -- reset video
    MENU {} {Video} {D: EGA/VGA: 80x43/50}
   ;- setup basic attribs..
   DYNARRAY attrib_bag[]
      attrib_bag["CANCLOSE"] = FALSE
      attrib_bag["CANMAXIMIZE"] = FALSE
      attrib_bag["CANRESIZE"] = FALSE
      attrib_bag["CANMOVE"] = FALSE
      attrib_bag["FLOATING"] = TRUE
      attrib_bag["HASSHADOW"] = FALSE
      attrib_bag["HASFRAME"] = FALSE
      attrib_bag["MAXIMIZED"] = FALSE
      attrib_bag["CANVASHEIGHT"] = 200

   ;- Triggers window
      attrib_bag["TITLE"] = "Triggers"
      attrib_bag["ORIGINCOL"] = 0
      attrib_bag["ORIGINROW"] = 24
      attrib_bag["WIDTH"] = 40
      attrib_bag["HEIGHT"] = 12
      attrib_bag["STYLE"] = 31  ;white on blue
      WINDOW CREATE ATTRIBUTES attrib_bag TO g_handle_bag["TRIGGERS"]
      PAINTCANVAS ATTRIBUTE 31 ALL

    ;-- Procs window
      attrib_bag["TITLE"] = "Procs"
      attrib_bag["ORIGINCOL"] = 40
      attrib_bag["ORIGINROW"] = 24
      attrib_bag["WIDTH"] = 40
      attrib_bag["HEIGHT"] = 12
      attrib_bag["STYLE"] = 111  ;white on brown
      WINDOW CREATE ATTRIBUTES attrib_bag TO g_handle_bag["PROCS"]
      PAINTCANVAS ATTRIBUTE 111 ALL

    ;- Memory  window
      attrib_bag["TITLE"] = "Memory"
      attrib_bag["HASFRAME"] = FALSE
      attrib_bag["ORIGINCOL"] = 55
      attrib_bag["ORIGINROW"] = 36
      attrib_bag["WIDTH"] = 25
      attrib_bag["HEIGHT"] = 13
      attrib_bag["STYLE"] = 32  ;black on green
      WINDOW CREATE ATTRIBUTES attrib_bag TO g_handle_bag["MEMORY"]
      PAINTCANVAS ATTRIBUTE 32 ALL

    ;- define dynarrays..
    DYNARRAY  tr_trigger_bag[]
    DYNARRAY  tr_procs_bag[]

    WINDOW SELECT h
    WINDOW SELECT h
    ECHO NORMAL

ENDPROC
Endproc.u("TracTunerCreateWindows_u")

; ============================================================
; 09-06-93
;
; ------------------------------------------------------------
PROC TracTunerDestroyWindows_u()
   PRIVATE Procname.a,
           h
   Procname.a = "TracTunerDestroyWindows_u"
   IF ISASSIGNED(g_handle_bag["TRIGGERS"]) AND
      ISWINDOW(g_handle_bag["TRIGGERS"]) THEN
      ECHO OFF
      h = SaveWindowHandle_n()
      ;- close windows
      WINDOW SELECT g_handle_bag["TRIGGERS"]
      WINDOW SELECT g_handle_bag["TRIGGERS"]
      WINDOW CLOSE
      WINDOW SELECT g_handle_bag["PROCS"]
      WINDOW SELECT g_handle_bag["PROCS"]
      WINDOW CLOSE
      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW CLOSE
      ;- release vars related to  TracTuner
      RELEASE VARS  g_handle_bag["TRIGGERS"],
                  g_handle_bag["PROCS"],
                  g_handle_bag["MEMORY"],
                  tr_trigger_bag,
                  tr_procs_bag,
                  tr_memory_bag,
                  g_cycle_n,
                  tr_varmem_a

      ; -- reset video
      MENU {} {Video} {C: EGA/VGA: 80x25}
      WINDOW SELECT h
      WINDOW SELECT h
      ;- upon shifting back to 80x25 a former max window will only
      ;  take up half the screen
      WINMAX
  ENDIF
ENDPROC


; ============================================================
; 09-06-93
; Main TracTuner proc
; ------------------------------------------------------------
PROC TracTuner_u(cycle_n,proc_a,trigger_a,type_a,rval_n)
   PRIVATE Procname.a,
           current_h
   Procname.a = "TracTuner_u"
   IF ISASSIGNED(TracTuner_l) AND TracTuner_l THEN
      IF NOT ISASSIGNED(g_cycle_n) THEN
         g_cycle_n = 0
      ENDIF
      ECHO OFF
      current_h = SaveWindowHandle_n()
      IF cycle_n <> g_cycle_n OR
         NOT ISASSIGNED(tr_trigger_bag) THEN
         ;--define or reset arrays
         DYNARRAY  tr_trigger_bag[]
         DYNARRAY  tr_procs_bag[]
      ENDIF

      TracTunerRefreshWindows_u(cycle_n,proc_a,trigger_a,type_a,rval_n)

      SETCANVAS DEFAULT
      STYLE
      WINDOW SELECT current_h
      WINDOW SELECT current_h
      ;--update cycle
      g_cycle_n = cycle_n
   ENDIF
ENDPROC
Endproc.u("TracTuner_u")

; ============================================================
; 09-06-93
; Sets up or removes TracTuner
; ------------------------------------------------------------
PROC TracTunerSetup_n()
   PRIVATE Procname.a
   Procname.a = "TracTunerSetup_n"
   ECHO OFF
   IF ISASSIGNED(TracTuner_l) THEN
      ;--first
      TracTunerDestroyWindows_u()
      RELEASE VARS TracTuner_l
   ELSE
     TracTuner_l = true
     TracTunerCreateWindows_u()
   ENDIF
   ECHO NORMAL
   RETURN 1
ENDPROC



; ============================================================
; 09-07-93
; Writes to windows if info is present
; ------------------------------------------------------------
PROC TracTunerRefreshWindows_u(cycle_n,proc_a,trigger_a,type_a,rval_n)
            ;type_a: "D" = default "C" = coherced
            ;proc_a: ""= no proc executed
            ;rval_n: current retval
   PRIVATE Procname.a,
           el,
           n,
           count_n,
           basetrigger_a,
           abrtrigger_a,
           h,
           var_a,
           rnew_a,
           rmod_a,
           rlck_a,
           w_r,
           winnum_a
   Procname.a = "TracTunerRefreshWindows_u"
   h = SaveWindowHandle_n()
   ;--triggers
   basetrigger_a =  trigger_a
   abrtrigger_a = TracTunerAbrTrigger_a(trigger_a)
   SETCANVAS g_handle_bag["TRIGGERS"]
   STYLE ATTRIBUTE 31
   IF g_cycle_n <> cycle_n THEN
      CLEAR
      PAINTCANVAS ATTRIBUTE 31 ALL
      WINDOW SELECT g_handle_bag["TRIGGERS"]
      WINDOW SCROLL g_handle_bag["TRIGGERS"] TO 0,0
      SETMARGIN OFF
      STYLE ATTRIBUTE 14
      @0,0 ?? FORMAT("W40,AC","* * TRIGGERS * *")
      @2,0
      STYLE ATTRIBUTE 31
   ENDIF
   SETMARGIN 3
   count_n = DYNARRAYSIZE(tr_trigger_bag)
   IF type_a = "C" THEN
      trigger_a = LOWER(trigger_a)
   ENDIF
   IF NOT ISBLANK(proc_a) THEN
      trigger_a =  CHR(251)+trigger_a
   ELSE
      trigger_a = " "+trigger_a
   ENDIF
   ;- place on screen
   ? STRVAL(count_n+1)+"-"+trigger_a
   ;--update cycle history
   tr_trigger_bag[count_n+1] = trigger_a

   ;--procs
   SETCANVAS g_handle_bag["PROCS"]
   STYLE ATTRIBUTE 111
   IF g_cycle_n <> cyclenumber_n THEN
      CLEAR
      PAINTCANVAS ATTRIBUTE 111 ALL
      WINDOW SELECT g_handle_bag["PROCS"]
      WINDOW SCROLL g_handle_bag["PROCS"] TO 0,0
      SETMARGIN OFF
      STYLE ATTRIBUTE 14
      @0,0 ?? FORMAT("W40,AC","* * PROCEDURES TRIGGERED * *")
      @2,0
      STYLE ATTRIBUTE 111
   ENDIF
   SETMARGIN 3
   count_n = DYNARRAYSIZE(tr_procs_bag)
   proc_a = abrtrigger_a+proc_a+" = "+STRVAL(rval_n)
   ;- place on screen
   ? proc_a
   ;--update cycle history
   tr_procs_bag[count_n+1] = proc_a

   ;-- memory status
   IF g_cycle_n <> cyclenumber_n OR
      basetrigger_a = "ARRIVEFIELD" OR
      rval_n = 1  THEN
      IF RECORDSTATUS("New") THEN
         rnew_a = "TRUE"
      ELSE
         rnew_a = "FALSE"
      ENDIF
      IF RECORDSTATUS("Modified") THEN
         rmod_a = "TRUE"
      ELSE
         rmod_a = "FALSE"
      ENDIF
      IF RECORDSTATUS("Locked") THEN
         rlck_a = "TRUE"
      ELSE
         rlck_a = "FALSE"
      ENDIF
      WINDOW LIST TO w_r
      winnum_a = STRVAL(ARRAYSIZE(w_r))
      SETCANVAS g_handle_bag["MEMORY"]
      STYLE ATTRIBUTE  32
      CLEAR
      PAINTCANVAS ATTRIBUTE 32 ALL
      WINDOW SELECT g_handle_bag["MEMORY"]
      WINDOW SCROLL g_handle_bag["MEMORY"] TO 0,0
      SETMARGIN OFF
      STYLE ATTRIBUTE 14
      @0,0 ?? FORMAT("W25,AC","* * INFO STATUS * *")
      @1,0
      STYLE ATTRIBUTE  32
      SETMARGIN 1
       ? "MEMLEFT()   = "+STRVAL(memleft())
       ? "RMEMLEFT()  = "+STRVAL(rmemleft())
       ? "RSTATUS-NEW = "+rnew_a
       ? "RSTATUS-MOD = "+rmod_a
       ? "RSTATUS-LCK = "+rlck_a
       ? "LINKTYPE    = "+LINKTYPE()
       ? "TABLE       = "+TABLE()
       ? "VAR-MEM     = "+tr_varmem_a
       ? "#IMAGES     = "+STRVAL(NIMAGES())
       ? "#WINDOWS    = "+winnum_a
   ENDIF
   WINDOW SELECT h
   WINDOW SELECT h
ENDPROC



; ============================================================
; 09-07-93
; returns abreviation of trigger
; ------------------------------------------------------------
PROC TracTunerAbrTrigger_a(eventype_a)
   PRIVATE Procname.a
   Procname.a = "TracTunerAbrTrigger_a"
      SWITCH
         CASE eventype_a = "VALCHECK"    :RETURN "VC-"
         CASE eventype_a = "DEPARTFIELD" :RETURN "DF-"
         CASE eventype_a = "DEPARTROW"   :RETURN "DR-"
         CASE eventype_a = "POSTRECORD"  :RETURN "PR-"
         CASE eventype_a = "DEPARTABLE"  :RETURN "DT-"
         CASE eventype_a = "DEPARTPAGE"  :RETURN "DP-"
         CASE eventype_a = "ARRIVEPAGE"  :RETURN "AP-"
         CASE eventype_a = "ARRIVEWINDOW":RETURN "AW-"
         CASE eventype_a = "ARRIVETABLE" :RETURN "AT-"
         CASE eventype_a = "ARRIVEROW"   :RETURN "AR-"
         CASE eventype_a = "ARRIVEFIELD" :RETURN "AF-"
         ;--added 4.5 triggers
         CASE eventype_a = "INSRECORD"     :RETURN "IR-"
         CASE eventype_a = "DELRECORD"     :RETURN "DL-"
         CASE eventype_a = "TOUCHFIELD"    :RETURN "TF-"
         CASE eventype_a = "ENDFIELDVIEW"  :RETURN "EF-"
         CASE eventype_a = "FIELDVIEW"     :RETURN "FV-"
         CASE eventype_a = "LOOKUP"        :RETURN "LK-"
         CASE eventype_a = "MENU"          :RETURN "MU-"
         CASE eventype_a = "UNDOCHANGE"    :RETURN "UC-"
         CASE eventype_a = "UNDODEL"       :RETURN "UD-"
         CASE eventype_a = "UNDOINS"       :RETURN "UI-"
         CASE eventype_a = "UNDOUNPOST"    :RETURN "UP-"
         CASE eventype_a = "CLOSE"         :RETURN "CL-"
         CASE eventype_a = "DONE"          :RETURN "DN-"
         CASE eventype_a = "OPEN"          :RETURN "OP-"
         CASE eventype_a = "FLYAWAY"       :RETURN "FA-"
         CASE eventype_a = "RECORDDELETED" :RETURN "RD-"
         CASE eventype_a = "RECORDCHANGED" :RETURN "RC-"
         CASE eventype_a = "ENDCYCLE"      :RETURN "EC-"
         CASE eventype_a = "REFRESH"       :RETURN "RF-"
         OTHERWISE : RETURN "NA-"
      ENDSWITCH
ENDPROC

;==============================================================
; Last compiled:  9/07/93
;
;--------------------------------------------------------------
PROC TRACMenudef_n()
   PRIVATE Procname_a
   Procname_a = "TRACMenudef_n"
   SHOWPOPUP " TracTuner System "  CENTERED
      "~S~tart TracTuner":"Start TracTuner System":"start",
      "~C~lose TracTuner":"Close TracTuner System":"close",
      "~V~ars Status"  :"Current Savevars":"save",
      "~Q~uit TracTuner Menu":"Close TracTuner menu":"quit"
   ENDMENU TO choice_a
      SWITCH
         CASE choice_a = "quit" :
            RETURN 1
         CASE choice_a = "close" :
            TracTunerSetup_n()
         CASE choice_a = "save" :
            TracTunerSaveVarList_n()
         CASE choice_a = "start" :
            TracTunerSetup_n()
      ENDSWITCH
    RETURN 1
ENDPROC

; ============================================================
; 09-10-93
; Complete variable list
; ------------------------------------------------------------
PROC TracTunerSaveVarList_n()
   PRIVATE Procname.a,
           tr_savevar_bag,
           v_n,
           save_a,
           buttonval_v
   Procname.a = "TracTunerSaveVarList_n"
   IF NOT ISASSIGNED(TracTuner_l) THEN
      BEEP BEEP RETURN 1
   ENDIF
   ECHO OFF
   QuickMsg_u("Loading Savevar setup...")
   SaveWorspace_u()
   IF SYSMODE() = "CoEdit" THEN DO_IT! ENDIF
   IF ISFILE("savevars.sc") THEN
      RUN NOREFRESH "RENAME SAVEVARS.SC SAVEVARS.OLD >nul"
   ENDIF
   SAVEVARS ALL
   ;--make sure it is written to disk and file is closed
   z = FILESIZE("savevars.sc")
   ;--- import this into a table
   MENU "TEIAT" SELECT "savevars.sc"
                SELECT "savevars"
   IF MENUCHOICE() = "Cancel" THEN SELECT "Replace" ENDIF
   ;--update var memory estimate
   tr_varmem_a = STRVAL(NRECORDS("savevars"))

   DYNARRAY tr_savevar_bag[]
   v_n = 0
   IF UPPER(TABLE()) <> "SAVEVARS" THEN
      VIEW "savevars"
   ENDIF
   MOVETO [Text]
   SCAN
      SWITCH
         CASE MATCH([],"Dynarray tr_..[]") : LOOP
         CASE MATCH([],"Array tr_..[..]..") : LOOP
         CASE MATCH([],"tr_..[..]..") : LOOP
         CASE MATCH([],";.."): LOOP  ;comment
         CASE ISBLANK([]): LOOP  ;blank
         OTHERWISE:
            v_n = v_n + 1
            tr_savevar_bag[STRVAL(v_n)] = []
      ENDSWITCH
   ENDSCAN
   CLEARIMAGE
   QuickMsg_u("")
  ; PaintPAL_Generated_Code_Begin(455766953)

  SHOWDIALOG "Savevars"
     @2,2 HEIGHT 46 WIDTH 75

     ; PaintPAL_Frame_Begin
     FRAME DOUBLE FROM 0,1 TO 40,71
     PAINTCANVAS ATTRIBUTE 127 0,1,0,71
     PAINTCANVAS ATTRIBUTE 112 40,1,40,71
     PAINTCANVAS ATTRIBUTE 127 0,1,40,1
     PAINTCANVAS ATTRIBUTE 112 0,71,40,71
     ; PaintPAL_Frame_End

     PICKDYNARRAY @1,2 HEIGHT 39 WIDTH 68
        tr_savevar_bag
        TAG "save"
        TO save_a

     PUSHBUTTON @42,29 WIDTH 15
        "Return"
        CANCEL
        VALUE "return"
        TAG "return"
        TO buttonval_v
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(455766953)
   IF ISFILE("savevars.old") THEN
       RUN NOREFRESH "RENAME SAVEVARS.OLD SAVEVARS.SC >nul"
   ENDIF
   RestoreWorkspace_u()
   RETURN 1
ENDPROC


